<?php
class ModelExtensionModuleFreeGift extends Model {
	public function addFreeGift($data) {
		$customer_group_id = implode(",", $this->request->post['customer_group_id']);

		$this->db->query("INSERT INTO " . DB_PREFIX . "free_gift SET min_amount = '" . (int)$data['min_amount'] . "', product_id = '" . (int)$data['product_id'] . "', free_delivery = '" . (int)$data['free_delivery'] . "', customer_group_id = '" . $this->db->escape($customer_group_id) . "', status = '" . (int)$data['status'] . "'");

		$free_gift_id = $this->db->getLastId();

		return $free_gift_id;
	}

	public function editFreeGift($free_gift_id, $data) {
		$customer_group_id = implode(",", $this->request->post['customer_group_id']);

		$this->db->query("UPDATE " . DB_PREFIX . "free_gift SET min_amount = '" . (int)$data['min_amount'] . "', product_id = '" . (int)$data['product_id'] . "', free_delivery = '" . (int)$data['free_delivery'] . "', customer_group_id = '" . $this->db->escape($customer_group_id) . "', status = '" . (int)$data['status'] . "' WHERE free_gift_id = '" . (int)$free_gift_id . "'");
	}

	public function deleteFreeGift($free_gift_id) {
		$this->db->query("DELETE FROM " . DB_PREFIX . "free_gift WHERE free_gift_id = '" . (int)$free_gift_id . "'");
	}

	public function getFreeGift($free_gift_id) {
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "free_gift WHERE free_gift_id = '" . (int)$free_gift_id . "'");

		return $query->row;
	}

	public function getFreeGifts($data = array()) {
		$sql = "SELECT * FROM " . DB_PREFIX . "free_gift fg LEFT JOIN " . DB_PREFIX . "product_description pd ON (fg.product_id = pd.product_id) WHERE pd.language_id = '" . (int)$this->config->get('config_language_id') . "'";

		$sort_data = array(
			'pd.name',
			'fg.status'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY pd.name";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = $this->db->query($sql);

		return $query->rows;
	}

	public function getTotalFreeGifts() {
		$query = $this->db->query("SELECT COUNT(*) AS total FROM " . DB_PREFIX . "free_gift");

		return $query->row['total'];
	}

	public function checkFreeGiftDuplicate($customer_group_ids, $min_amount, $free_gift_id) {
		foreach ($customer_group_ids as $customer_group_id) {
			$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "free_gift WHERE customer_group_id LIKE '%" . (int)$customer_group_id . "%' AND min_amount = '" . (int)$min_amount . "' AND status = '1' AND free_gift_id != '" . (int)$free_gift_id . "'");

			if ($query->row) {
				return true;
			}
		}

		return false;
	}

	public function getProducts($data = array()) {
		$sql = "SELECT * FROM " . DB_PREFIX . "product p LEFT JOIN " . DB_PREFIX . "product_description pd ON (p.product_id = pd.product_id) WHERE pd.language_id = '" . (int)$this->config->get('config_language_id') . "' AND product_type = '1'";

		if (!empty($data['filter_name'])) {
			$sql .= " AND pd.name LIKE '" . $this->db->escape($data['filter_name']) . "%'";
		}

		$sql .= " GROUP BY p.product_id ORDER BY pd.name ASC";

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = $this->db->query($sql);

		return $query->rows;
	}
}