<?php
class ModelExtensionTotalFreeGift extends Model {
	public function removeGiftProducts() {
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "product WHERE product_type = '1'");

		// Delete gift products from cart
		if (version_compare(VERSION , '2.2.0.0') <= 0) {
			foreach ($query->rows as $gift_product) {
				$this->db->query("DELETE FROM " . DB_PREFIX . "cart WHERE product_id = '" . (int)$gift_product['product_id'] . "' AND customer_id = '" . (int)$this->customer->getId() . "' AND session_id = '" . $this->db->escape($this->session->getId()) . "'");
			}
        } else {
        	foreach ($query->rows as $gift_product) {
				$this->db->query("DELETE FROM " . DB_PREFIX . "cart WHERE product_id = '" . (int)$gift_product['product_id'] . "' AND api_id = '" . (isset($this->session->data['api_id']) ? (int)$this->session->data['api_id'] : 0) . "' AND customer_id = '" . (int)$this->customer->getId() . "' AND session_id = '" . $this->db->escape($this->session->getId()) . "'");
			}
        }
	}

	public function getFreeGifts($data = array()) {
		$sql = "SELECT * FROM " . DB_PREFIX . "free_gift fg LEFT JOIN " . DB_PREFIX . "product_description pd ON (fg.product_id = pd.product_id) WHERE pd.language_id = '" . (int)$this->config->get('config_language_id') . "' AND fg.customer_group_id LIKE '%" . (int)$this->config->get('config_customer_group_id') . "%' AND fg.status = '1' ORDER BY fg.min_amount ASC";

		$query = $this->db->query($sql);

		return $query->rows;
	}

	public function getTotal($total) {
		$this->load->model('catalog/product');

		if (version_compare(VERSION , '2.2.0.0') <= 0) {
			$this->load->language('total/free_gift');
		} else {
			$this->load->language('extension/total/free_gift');
		}	

		$free_gifts = $this->getFreeGifts();

        $gift_product_id = 0;
        $gift_product_qty = 0;
        $gift_delivery = '';

        $sub_total = $this->cart->getSubTotal();

        foreach ($free_gifts as $free_gift) {
            if ($sub_total >= $free_gift['min_amount']) {
                $gift_product = $this->model_catalog_product->getProduct($free_gift['product_id']);

                $gift_product_qty = $gift_product['quantity'];
                $gift_product_id = $free_gift['product_id'];
                $gift_delivery = $free_gift['free_delivery'];
            }
        }

        if ($gift_product_id != 0 && $gift_product_qty != 0 && $gift_delivery == 1) {
            $discount_total = 0;

            if (isset($this->session->data['shipping_method'])) {
				if (!empty($this->session->data['shipping_method']['tax_class_id'])) {
					$tax_rates = $this->tax->getRates($this->session->data['shipping_method']['cost'], $this->session->data['shipping_method']['tax_class_id']);

					foreach ($tax_rates as $tax_rate) {
						if ($tax_rate['type'] == 'P') {
							$total['taxes'][$tax_rate['tax_rate_id']] -= $tax_rate['amount'];
						}
					}
				}

				$discount_total += $this->session->data['shipping_method']['cost'];
			}

			// If discount greater than total
			if ($discount_total > $total['total']) {
				$discount_total = $total['total'];
			}

			if ($discount_total > 0) {
				$total['totals'][] = array(
					'code'       => 'free_gift',
					'title'      => $this->language->get('text_free_gift'),
					'value'      => -$discount_total,
					'sort_order' => $this->config->get('total_free_gift_sort_order')
				);

				$total['total'] -= $discount_total;
			}
        }
	}
}